using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;

namespace DynamiteXml.HelperLogic
{
    /// <summary>
    /// A class that represents an assembly name and a full type name that
    /// holds the type information of the IDynamiteXml object.
    /// </summary>
    public class TypeIdentifier
    {
        /// <summary>
        /// Creates a new TypeIdentifier object.
        /// </summary>
        public TypeIdentifier()
        {
            //
            // intentionally left blank
            //
        }

        private string assemblyName;

        /// <summary>
        /// The assembly name of the IDynamiteXml implementing class.
        /// </summary>
        [XmlElement("Assembly")]
        public string AssemblyName
        {
            get
            {
                return assemblyName;
            }
            set
            {
                assemblyName = value;
            }
        }

        private string typeName;
        /// <summary>
        /// The type of the IDynamiteXml implementing class.
        /// </summary>
        [XmlElement("Name")]        
        public string TypeName
        {
            get
            {
                return typeName;
            }
            set
            {
                typeName = value;
            }
        }
    }
}
